//============================================================
// STUDENT NAME: <your name>
// MATRIC NO.  : <matric no.>
// NUS EMAIL   : <your NUS email address>
// COMMENTS TO GRADER:
// <comments to grader, if any>
//
// ============================================================
//
// FILE: prefixsums.frag


#extension GL_ARB_texture_rectangle : require

// The GL_EXT_gpu_shader4 extension extends GLSL 1.10 with 32-bit integer
// representation, integer bitwise operators and the modulus operator (%).
#extension GL_EXT_gpu_shader4 : require


uniform sampler2DRect InputTex;	 // The input texture.

// Not all these uniform variables need to be used.
uniform int TexWidth;
uniform int TexHeight;
uniform int PassCount;  // For the very first pass, PassCount == 1;
uniform int Stride;     // Stride == 2^(PassCount - 1);


void main()
{
	int k = int(gl_FragCoord.y) * TexWidth + int(gl_FragCoord.x);
	gl_FragColor = texture2DRect( InputTex, gl_FragCoord.xy );
	
	if ( k >= Stride )
	{		
		int m = k - Stride;
		int mRow = m / TexWidth;
		int mCol = m % TexWidth;
		
		gl_FragColor += texture2DRect( InputTex, vec2(mCol, mRow) + vec2(0.5,0.5) );
	}
}

