#ifndef _IMAGE_IO_H_
#define _IMAGE_IO_H_

typedef unsigned char uchar;

/////////////////////////////////////////////////////////////////////////////
// Deallocate the memory allocated to (*imageData) returned by 
// the function ReadImageFile().
// (*imageData) will be set to NULL.
/////////////////////////////////////////////////////////////////////////////
extern void DeallocateImageData( uchar **imageData );

/////////////////////////////////////////////////////////////////////////////
// Read a image from the input filename. 
// Returns 1 if successful or 0 if unsuccessful.
// The returned image data will be pointed to by (*imageData).
// The image width, image height, and number of components (color channels) 
// per pixel will be returned in (*imageWidth), (*imageHeight),
// and (*numComponents).
// The value of (*numComponents) can be 1, 2, 3 or 4.
// The returned image data is always packed tightly with red, green, blue,
// and alpha arranged from lower to higher memory addresses. 
// Each color channel take one byte.
/////////////////////////////////////////////////////////////////////////////
extern int ReadImageFile( const char *filename, uchar **imageData,
                   int *imageWidth, int *imageHeight, int *numComponents );

#endif
